#!/bin/sh

# Crash-diagnostics tool will use user "vmware-system-user" to fetch logs
# Due to the permission issue, we need to copy all those logs to another folder to let Crash-diagnostics grab them.

GETLOGS=$1
LOG_DIR=/home/vmware-system-user/support-bundle

copyDirectories(){
    from=$1
    to=$2
    if [ -d $from ]; then
        mkdir -p $to
        # copy the log to its destination
        cp -Lr $from $to
    fi
}

if [ $GETLOGS -eq 1 ]; then
    echo "Collecting pod & containers logs"
    declare -A logs=(["/var/log/containers"]="${LOG_DIR}" \
                    ["/var/log/pods"]="${LOG_DIR}" \
                    ["/var/lib/docker/containers"]="${LOG_DIR}/docker")

    for item in "${!logs[@]}"
    do
        echo "  - ${item}"
        copyDirectories ${item} ${logs["${item}"]}
    done
fi

# Collect audit logs
echo "Collecting audit logs"
copyDirectories /var/log/kubernetes ${LOG_DIR}

if [ -d "/var/log/antrea" ]; then
    # Collect antrea logs
    echo "Collecting antrea logs"
    copyDirectories /var/log/antrea ${LOG_DIR}
fi

chown -R vmware-system-user ${LOG_DIR}
